<?php

ob_start();

try {

    require_once realpath(
        dirname(__FILE__) . DIRECTORY_SEPARATOR .
            '..' . DIRECTORY_SEPARATOR .
            '..' . DIRECTORY_SEPARATOR .
            'app' . DIRECTORY_SEPARATOR .
            'engine') . DIRECTORY_SEPARATOR . 'configure.inc.php';

    if (false === array_key_exists('field', $_POST)) {
        throw new Exception('No field in group request.');
    }

    $filter = new stdClass();
    if (array_key_exists('filter', $_POST)) {
        $filter = json_decode(json_encode($_POST['filter'], JSON_FORCE_OBJECT));
    }

    if (false === array_key_exists('BaseValue', $filter)) {
        $filter->BaseValue = new stdClass();
    }

    /*
     * Bring AccsList to format.
     */
    if (array_key_exists('AccsList', $filter->BaseValue)) {

        $accs_list = [];

        foreach ($filter->BaseValue->AccsList->Accs as $accs_list_item) {
            array_push($accs_list, ['Key' => $accs_list_item, 'Value' => 1]);
        }

        $filter->BaseValue->AccsList->Accs = $accs_list;
    }


    $filter->BaseValue->State = new stdClass();
    $filter->BaseValue->State->Sold = 0;
    $filter->BaseValue->State->Deleted = 0;

    $grouped = CarApiClient :: groupVehicleField($_POST['field'], $filter);

    if (array_key_exists('Fields', $grouped)) {

        $grouped = $grouped->Fields;
        switch ($_POST['field']) {

            case 'Area':            $grouped = CarApiClient :: translateValues($grouped, 'FullCategory'); break;
            case 'Fuel':            $grouped = CarApiClient :: translateValues($grouped, 'Fuel'); break;
            case 'Gearbox':         $grouped = CarApiClient :: translateValues($grouped, 'Gearbox'); break;
            case 'Category':        $grouped = CarApiClient :: translateValues($grouped, 'Category'); break;
            case 'RegDate':         $grouped = prepareRegDates($grouped); break;
            case 'Power':           $grouped = preparePowers($grouped); break;
            case 'Km':              $grouped = prepareKms($grouped); break;
            case 'Price.Client':    $grouped = preparePrices($grouped); break;
            case 'AccsList':        $grouped = getUniquedAccsList($grouped); break;
        }
    }

    echo json_encode($grouped);
}
catch (Exception $e) {

    error_log('[' . basename(__FILE__) .'] ' . $e->getMessage());

    header("HTTP/1.0 500 Internal Server Error");
    echo json_encode($e->getMessage());
}

ob_end_flush();
?>