<?php

ob_start();

try {

    require_once realpath(
        dirname(__FILE__) . DIRECTORY_SEPARATOR .
        '..' . DIRECTORY_SEPARATOR .
        '..' . DIRECTORY_SEPARATOR .
        'app' . DIRECTORY_SEPARATOR .
        'engine') . DIRECTORY_SEPARATOR . 'configure.inc.php';

	$filter = new stdClass();
    $filter->BaseValue = new stdClass();
    $filter->BaseValue->State = new stdClass();
    $filter->BaseValue->State->Sold = 0;     // keine verkauften FZ
    $filter->BaseValue->State->Deleted = 0;  // keine gelöschten FZ

    $fields = array();

    $page_num   =  1;
    $limit      =  8;

    // Offset berechnen
    $start = ($page_num - 1) * $limit;

    $order = 'CreationDate';
    $direction = 'DESC';

    $filtered = CarApiClient :: filterVehicle($filter, array('Field' => $fields), $start, $limit, $order, $direction);

    header("Content-Type: application/json");

    echo json_encode(array(
        'items'     => $filtered['VehicleFilterResponse']->Vehicle,
        'total'     => $filtered['TotalCount'],
        'page_num'  => $page_num
    ));
}
catch (Exception $e) {

    error_log('[' . basename(__FILE__) .'] ' . $e->getMessage());

    header("HTTP/1.0 500 Internal Server Error");
    echo json_encode($e->getMessage());
}

ob_end_flush();
?>